#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    

import alsaaudio,os
import gtk

class alsasetter():
    
    def __init__(self):
        
        self.NOTHING = -1
        self.MIC = 0
        self.GSM_IN = 1
        self.GSM_MIC= 2
        
        #TODO: better /etc/dictator ???       
        #self.state_folder =__file__[0:__file__.rfind("/")]
        self.state_folder ="/usr/share/scenarios/dictator"
        self.recType = self.MIC
        
        self.backup_old_state()
        
        # GUI -->
        self.main_box = gtk.VBox(True,0)
        
        self.message = gtk.Label("Choose Recordmode")
        self.main_box.pack_start(self.message,False,False,10)
        
        # BUTTONS:
        self.gsm_mic_but = gtk.Button("GSM & Mic")
        self.gsm_mic_but.set_property("height-request",100)
        self.gsm_mic_but.connect("clicked",self.set_in_out_rec)
        
        self.main_box.pack_start(self.gsm_mic_but,True,True,0)
        
        self.gsm_but = gtk.Button("GSM-In")
        self.gsm_but.connect("clicked",self.set_gsm_in_rec)
        self.gsm_but.set_property("height-request",100)
        
        self.main_box.pack_start(self.gsm_but,True,True,0)
        
        self.mic_but = gtk.Button("Mic")
        self.mic_but.connect("clicked",self.set_mic_rec)
        self.mic_but.set_property("height-request",100)
        
        self.main_box.pack_start(self.mic_but,True,True,0)
        
        # WINDOW
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.resize(480,640)
        self.window.set_title("Alsasetter")
        self.window.connect("destroy", self.hide)
        self.window.connect("delete-event", self.hide)
        self.window.add(self.main_box)
        
        # <-- GUI
        self.hide()
        
    # configure alsa for recording a whole phone-call
    # sound from gsm and from body-mic
    def set_in_out_rec(self,widget=None):
        ret = False

        try:
            #TODO: LOOKUP RIGHT VALUES
            os.popen("amixer sset 'Capture Right Mux' PGA")
            os.popen("amixer sset 'Capture Left Mux' 'Line or RXP-RXN'")
            print "record gsm and mic sound"
        except:
            print "alsa-state for in-out-rec could not be set!"
        else:
            self.recType = self.GSM_MIC
            ret= True
        # --> 2-channel recording
        if (self.window.get_property("visible")):
            self.hide()
        return ret
    
    # configure alsa to record what's coming from gsm - the voice of the other
    def set_gsm_in_rec(self,widget=None):
        ret = False
        # works fine ! :)
        try:
            os.popen("amixer sset 'Capture Right Mux' 'Line or RXP-RXN'")
            os.popen("amixer sset 'Capture Left Mux' 'Line or RXP-RXN'")
            print "record incoming gsm-sound"
        except:
            print "alsa-state for gsm-in-rec could not be set!"
        else:
            self.recType = self.GSM_IN
            ret= True
        # --> 2-channel recording
        if (self.window.get_property("visible")):
            self.hide()
        return ret

    
    # configure alsa to record from body mic
    def set_mic_rec(self,widget=None):
        ret = False
        try:
                os.popen("amixer sset 'Capture Right Mux' PGA")
                os.popen("amixer sset 'Capture Left Mux' PGA")
                print "record mic sound"
        except:
                print "alsa-state for mic-rec could not be set!"    
        else:
                self.recType = self.MIC
                ret= True
        if (self.window.get_property("visible")):
            self.hide()
            
        return ret
    
    def backup_old_state(self):
        ret = os.system("alsactl store -f /tmp/tmp.state")
        if ret==0:
            print "old_state has been backed up to /tmp/tmp.state"
            
    def load_recstate(self):
        ret=os.system("alsactl restore -f "+self.state_folder+ "/dictator_rec.state")
        
        if (self.recType == self.MIC or self.recType == self.NOTHING):
            self.set_mic_rec()
        elif self.recType == self.GSM_IN:
            self.set_gsm_in_rec()
        elif self.recType == self.GSM_MIC:
            self.set_in_out_rec()
            
        if ret==0:
            print "dictator_rec.state has been loaded."
        
    def load_playstate(self):
	    ret=os.system("alsactl restore -f "+self.state_folder+ "/dictator_play.state")
	    if ret==0:
	        print "dictator_play.state has been loaded."
	        
    def reload_old_state(self):
        ret=os.system("alsactl restore -f /tmp/tmp.state")
        if ret==0:
            print "old state has been reloaded."
        else:
            print "old state could not be reloaded."
                  
    def hide(self,widget=None,foobar=None):
        self.window.hide()
        
    def show(self,widget=None):
        self.window.show_all()
        
    def get_rectype(self):
        ret=''
        if self.recType==-1:
            ret = "NO RECORD MODE"
        elif self.recType == 0:
            ret = "RECORD MIC"
        elif self.recType == 1:
            ret ="RECORD GSM_IN"
        elif self.recType == 2:
            ret = "RECORD GSM AND MIC"
            
        return ret
        
        
