#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    

import os.path
import pygtk
pygtk.require('2.0')
import gtk

class DictatorConfig:
    
    __configfile = None
    __global_conf = "/etc/dictator.conf"
    __user_conf = "/home/root/.dictator.conf"
    
    #representing the config-options in dictator.conf
    __folder = ''
    __recordlimit = 0
    __soundcard = 'hw:0,0'
    __sounddetection = False
    __rate = 8000
    #...
    
    def __init__(self,configfile):
       
        
        # set configfile or default - default-default should be /etc/dictator.conf
        self.__configfile=configfile
        
        ok = self.fetch_configs()
        # message
        print ok
        
        #workaround for setting the rate via config-window
        self.tmp_rate=self.get_rate()
        
        # GUI -->
        self.main_box = gtk.VBox(False,0)
        
        self.message = gtk.Label("Configuration:")
        self.main_box.pack_start(self.message,True,True,10)
        
        # BUTTONS, LABELS & TEXT-ENTRIES:
        self.folder_label = gtk.Label("Folder:")
        self.folder_entry = gtk.Entry(0)
        self.folder_entry.set_text(self.get_folder())
        self.folder_entry.connect("changed",self.window_set_folder)
        
        self.folder_box = gtk.HBox(True,5)
        self.folder_box.pack_start(self.folder_label,False,False,0)
        self.folder_box.pack_start(self.folder_entry,False,False,0)
        self.main_box.pack_start(self.folder_box,True,True,0)
        
        self.soundcard_label = gtk.Label("Soundcard:")
        self.soundcard_entry=gtk.Entry(0)
        self.soundcard_entry.set_text(self.get_soundcard())
        self.soundcard_entry.connect("changed",self.window_set_soundcard)
        
        self.sc_box=gtk.HBox(True,5)
        self.sc_box.pack_start(self.soundcard_label,False,False,0)
        self.sc_box.pack_start(self.soundcard_entry,False,False,0)
        self.main_box.pack_start(self.sc_box,True,True,0)
        
        self.rate_label = gtk.Label("Samplerate:")
        self.rate_entry = gtk.Entry(0)
        self.rate_entry.set_text(str(self.get_rate()))
        self.rate_entry.connect("changed",self.window_set_rate)
        
        self.rate_box= gtk.HBox(True,5)
        self.rate_box.pack_start(self.rate_label,False,False,0)
        self.rate_box.pack_start(self.rate_entry,False,False,0)
        self.main_box.pack_start(self.rate_box,True,True,0)
        
        self.store_but = gtk.Button("store config values")
        self.store_but.set_property("height-request",100)
        self.store_but.connect("clicked",self.store_config)
        
        self.close_but =gtk.Button("close")
        self.close_but.set_property("height-request",100)
        self.close_but.connect("clicked",self.close_window)
        
        self.button_box=gtk.HBox(True,5)
        self.button_box.pack_start(self.store_but,True,True,0)
        self.button_box.pack_start(self.close_but,True,True,0)
        
        self.main_box.pack_end(self.button_box,True,True,0)
        
        
        # WINDOW
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.resize(480,640)
        self.window.set_title("Dictator Config")
        self.window.connect("destroy", self.close_window)
        self.window.connect("delete-event", self.close_window)
        self.window.add(self.main_box)
        #self.window.show_all()
        self.window.hide()
        # <-- GUI
        
    def fetch_configs(self): 
        fobj=None
        used_conf = ''
                    
        if self.get_configfile()== None:
            if os.path.exists(self.get_user_conf()):
                used_conf = self.get_user_conf()
                fobj = open(used_conf,"r")
            elif os.path.exists(self.get_global_conf()):
                used_conf = self.get_global_conf()
                fobj = open(used_conf)
        else:
            if os.path.exists(self.get_configfile()):
                used_conf = self.get_configfile()
                fobj = open(used_conf,"r")
            
        if fobj == None:
            ok = "no configfile found, using standard-config"
            self.set_folder("/media/card")
            self.set_recordLimit(0)
            self.set_rate(8000)
            self.set_soundcard('hw:0,0')
            self.set_sounddetection(False)
        else:
            ok = "using " + used_conf + " for configuration"
            self.read_lines(fobj)
            fobj.close 

        return ok
    
    def read_lines(self,fobj):
        for line in fobj.readlines(): 
            line=line.strip()
            if (line[:1] != "#" and "=" in line):#commented lines
                confs = line.split("=")
                if (confs[0]=="folder"):# key
                     self.set_folder(confs[1]) # value
                     
                elif (confs[0]=="recordLimit"): # key
                    self.set_recordLimit(confs[1]) # value
                    
                elif (confs[0]=="soundcard"):
                    self.set_soundcard(confs[1])
                    
                elif (confs[0]=="rate"):
                    self.set_rate(confs[1])
                    
                elif (confs[0]=="sounddetection"):
                    self.set_sounddetection(confs[1])
    def open_window(self,widget=None):
        self.window.show_all()
          
    def close_window(self,window=None,widget=None):
        self.window.hide()
        
    def store_config(self,widget=None):
        try:
            fobj_r=open(self.get_global_conf(),"r")
            lines_r=fobj_r.readlines()
        except:
            print "opening "+self.get_global_conf() +" failed!"
        finally:
            fobj_r.close()
        try:
            fobj_w = open(self.get_global_conf(),"w+")
            for line_r in lines_r: 
                if line_r[0:6]=="folder":
                    print self.get_folder()
                    line_r = "folder="+ self.get_folder() +"\n"
                elif line_r[0:9]=="soundcard":
                    line_r= "soundcard="+self.get_soundcard()+"\n"
                elif line_r[0:4] =="rate":
                    line_r="rate="+str(self.get_rate())+"\n"
                fobj_w.write(line_r)
        except:
            print "storing configuration in "+self.get_global_conf() +" failed!"
        else:
            print "configurations saved to "+ self.get_global_conf()
        finally:
            fobj_w.close()
        

                          
    #getter & setter        
    def get_folder(self):
        return self.__folder.strip()
    
    def get_recordLimit(self):
        return self.__recordlimit.strip()
        
    def window_set_folder(self,widget):
        folder = self.folder_entry.get_text()
        self.set_folder(folder)
    
    def set_folder(self,folder):
        self.__folder=str(folder)
        
    def set_recordLimit(self,rl):
        self.__recordlimit=int(rl)
        
    def window_set_rate(self,widget):
        rt=None
        rate = self.rate_entry.get_text()
        try:
            rt = int(rate)
        except:
            rt = str(self.get_rate())
            print "'"+rate+"' is not allowad as samplerate! rate will remain: "+ rt
            self.rate_entry.set_text(str(rt))
        else:
            self.set_rate(rt)
        
    def set_rate(self,rt):
        self.__rate = int(rt)
        
    def get_rate(self):
        return self.__rate
    
    def set_sounddetection(self,sd):
        if (sd == 1):
            self.__sounddetection = True
        else:
            #default-value
            self.__sounddetection = False
            
    def get_sounddetection(self):
        return self.__sounddetection
        
    def window_set_soundcard(self,widget):
        sc=self.soundcard_entry.get_text()
        self.set_soundcard(sc)
        
    def set_soundcard(self,sc):
        self.__soundcard = str(sc)
    
    def get_soundcard(self):
        return self.__soundcard
    
    def get_configfile(self):
        return self.__configfile
    
    def set_configfile(self,cfile):
        self.__configfile = str(cfile)
        
    def get_user_conf(self):
        return self.__user_conf
    
    def get_global_conf(self):
        return self.__global_conf
    
            
            
