#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    

import threading,Queue
import wave
from gtk.gdk import threads_leave,threads_enter
from time import time,sleep
import datetime

class saveThread(threading.Thread):
# gathers frames read by the pcm-device in a list 
# and saves them to a wave-file one by one in the right order
    testfile = ''   # filename
    data_list= []   # list of sound-data
    track = None    # representing the wav-file
    # variables for ogg-encoding
    vd = None 
    os = None 
    og = None
    
    def __init__(self,filename,channels,rate,samplewidth):
        threading.Thread.__init__(self)
        
        saveThread.testfile = filename
        self.channels = channels
        self.rate = rate
        self.samplewidth = samplewidth
           
        self.setDaemon(False)
        #bool set by function stop
        self.stop_thread= False
        # wave-part:
        self.open_file()
        
        # ogg-part:
        ##self.open_ogg_file()
        
    def open_file(self):
        # open wave-file in write mode
        # means creating a new one
        saveThread.track = wave.open(saveThread.testfile, "wb")
        saveThread.track.setnchannels(self.channels)
        saveThread.track.setframerate(self.rate)
        saveThread.track.setsampwidth(self.samplewidth)
        
        
    def open_ogg_file(self):
        # open file - create new one
        saveThread.track = open(saveThread.testfile, 'wb')
        print 'opening file'
        # create header
        saveThread.vd = ogg.vorbis.VorbisInfo(channels = 1,
                           rate = 8000,
                           quality = 0.2).analysis_init()
                           
        saveThread.os = ogg.OggStreamState(5)
        # here it crashes on openmoko
        map(saveThread.os.packetin, saveThread.vd.headerout())
        saveThread.og = saveThread.os.flush()
        print saveThread.og
        while saveThread.og: 
            saveThread.og.writeout(saveThread.track)
            saveThread.og = saveThread.os.flush()
        print 'header written'
        
    def run(self):
        #save-loop
        while self.stop_thread == False:
            if len(saveThread.data_list) > 0: #liste not empty
                chunk = saveThread.data_list[0]
                
                saveThread.track.writeframesraw(chunk)
                # ogg-part:
                ##print '--> write data2ogg'
                ##self.save_ogg(chunk)
                
                saveThread.data_list.pop(0)    
            else:
                sleep(0.1)
	saveThread.data_list = []
                
    def save_ogg(self,datachunk):
        print len(datachunk)
        if not datachunk: #wenn nix mehr drin iss, nix schreiben und ende
            saveThread.vd.write(None)
            print 'nothing written'
        else:
            saveThread.vd.write(datachunk)
            print 'written'
            vb = saveThread.vd.blockout()
            while vb:
                print 'vb != None'
                # here it crashes on my laptop
                vb.analysis()
                print 'analysis'
                vb.bitrate_addblock()
                print 'addblock'
        
                op = saveThread.vd.flushpacket()
                while op:
                    saveThread.os.packetin(op)
                    while not eos:
                        saveThread.og = saveThread.os.pageout()
                        if not saveThread.og: break
                        saveThread.og.writeout(fout)
                        eos = saveThread.og.eos()
                    op = saveThread.vd.bitrate_flushpacket()
                vb = saveThread.vd.blockout()  
    
    def close(self):
        # track is ready and "full" --> close it
        saveThread.track.close()
        
    def stop(self):
        self.stop_thread = True
        pass
    
    def sound_detect(self,sound):
        noise = False
        # get max amplitutde of one data-chunk of 80 frames
        # less or more frames at once ?
        # if amplitude is higher then e.g. 600 (?) return true(means record!)
        # else false (means ignore chunk)
        
        #problem with 16-bit frames?
        sound_limit = 600
        
        max_noise = 0
        min_noise = 65536
        
        for sample in sound:
            value = int(sample)
            
            if value > noise_value:
                noise_value = value
            
            if value < min_noise:
                min_noise
            
        if max_noise-min_noise > sound_limit:
            noise = True
               
        return noise
    
    
class TimelabelUpdater(threading.Thread):
    # not really reliable because of business of gtk-mainthread

    def __init__(self,timelabel,duration=None,track=None,framerate=None):
        threading.Thread.__init__(self)
        # reference to timelabel
        self.timelabel = timelabel
        self.stop_thread = False
        self.pause_thread = False
        # gathering time the playing has been paused
        self.pause_time = 0.0
        
        #track-related information for play-time-displaying
        # recording starts TimeLabelUpdater without duration and track
        self.duration = duration
        self.track = track
        self.framerate = framerate
        
        # time and date
        self.begin = datetime.datetime.fromtimestamp(time())
               
    def run(self):
        if (self.track == None):
            #loop for rec-time-displaying
            while not self.stop_thread:
                if not self.pause_thread:
                    #begintime should be nearly 0 or your computer is far too slow ;-)
                    dur = datetime.datetime.fromtimestamp(time()-self.pause_time) - self.begin
                    mins = dur.seconds/60
                    secs = dur.seconds%60
                    
                    threads_enter()
                    # updating the timelabel
                    self.timelabel.set_markup('<span size="12000">'+ (str(mins) if mins > 9 else '0'+str(mins)) + ':' + (str(secs) if secs > 9 else '0'+str(secs)) +self.nn(self.duration)+'</span>')
                    threads_leave()
                else:
                    #pause
                    sleep(0.1)
                    self.pause_time += 0.1
                sleep(0.2)
        else:
            #loop for play-time displaying
            while not self.stop_thread:
                if not self.pause_thread:   
                    position = round((1.0 * self.track.tell())/self.framerate)
                    if position > 60.0:
                        mins = int(position/60)
                        secs = int(position%60)
                        if mins < 10:
                            mins = '0' + str(mins)
                        if secs < 10:
                            secs = '0' + str(secs-1)
                        playtime = str(mins) + ":" + str(secs)
                    else:
                        
                        playtime = "00:" + ('0' + str(int(position)) if position < 10 else str(int(position)))
                        
                    threads_enter()
                    # updating the timelabel
                    self.timelabel.set_markup('<span size="12000">' + playtime + self.nn(self.duration) + '</span>')
                    threads_leave()
                else:
                    #pause
                    sleep(0.1)
                    self.pause_time += 0.1
                sleep(0.24)
                
    def stop(self):
        self.stop_thread = True

    def pause(self):
        self.pause_thread = True
    
    def resume(self):
        if self.pause_thread == True:
            self.pause_thread = False
    
    def nn(self,dur):
        if dur == None: # while recording there is no given duration - so return nothing :)
            return ''
        else:
            # while playing
            return '/'+dur
