#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    

import pygtk
pygtk.require('2.0')
import gtk, os

gtk.gdk.threads_init()

import recPage
import playPage
import playrecthread
# http://downloads.openmoko.org/repository/experimental/armv4t/python-pyalsaaudio_0.4-ml0_armv4t.ipk
import alsaaudio,os
import alsasetter
#import ogg
import config

class DiktatorGtk:

    def destroy(self, widget, data=None):
        # called when window is closed
        print "Enough dictation for now! \nWhat about democracy further on?"
        gtk.main_quit()
        self.aset.reload_old_state()
        if (not self.pr_thread is None):
            #stop the playrecthread
            self.pr_thread.kill()
        
    def __init__(self,configfile):
        
        self.aset = alsasetter.alsasetter()
                
        #load config - with specified configfile 
        #(using /etc/dictator.conf if none was specified)
        self.conf = config.DictatorConfig(configfile)
        
        #start playrecthread
        try:
            self.pr_thread = playrecthread.PlayRecThread(self.conf,self.aset)
            self.pr_thread.start()
        except:
            print "ALSA was unable to open slave. Please restart!"
            self.pr_thread = None
            
        #create a new window
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.resize(480,640)
        self.window.set_title("Diktator")
        self.window.connect("destroy", self.destroy)
        
        #Notebook - Tabs
        self.tabs = gtk.Notebook()
        self.tabs.set_property("homogeneous",True)
        self.tabs.set_property("tab-vborder",15)
        
        # Pictures
        self.rec_tab_img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_RECORD, gtk.ICON_SIZE_BUTTON)
        self.rec_tab_img.set_property("icon-size",6)
        self.play_tab_img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)   
        self.play_tab_img.set_property("icon-size",6)  
        
        #recPage - actually returning a VBox
        # arguments are just given to access them via functions of recPage
        self.recp = recPage.RecPage(self.pr_thread,self.conf,self.aset)
        self.tabs.append_page(self.recp.mainBox,self.rec_tab_img)
        self.tabs.child_set(self.recp.mainBox,"tab-expand",True)
        
        self.aset.window.connect("hide",self.recp.update_record_label)
        
        #playPage
        self.playp = playPage.PlayPage(self.pr_thread,self.conf)
        img = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)   
        img.set_property("icon-size",6)  
        self.tabs.append_page(self.playp.mainBox,self.play_tab_img) 
        self.tabs.child_set(self.playp.mainBox,"tab-expand",True)
        self.tabs.connect("switch-page",self.reload_playp)  
        
        self.vbox = gtk.VBox()  
        self.vbox.add(self.tabs)
        
        #Pack Notebook into Window
        self.window.add(self.vbox)
        
        #TADAAAA!!!
        self.window.show_all()
        
        #hiding timelabels
        self.playp.eb.hide()
        self.recp.eb.hide()      

    def reload_playp(self,notebook=None,page=None,page_num=None):
	# loads alsa-state for playback of recorded files
	
        # when switching to playPage --> update the filelist
        if page_num == 1:
            self.aset.load_playstate()
            self.playp.update_list()
            
    def main(self):
        # entering gtk-mainloop - there it is waiting for signals from
        # the gui to execute functions connected to buttons and so on
        gtk.main()

        
if __name__ == "__main__":
    main_GUI = DiktatorGtk()
    main_GUI.main()
