#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    
import pygtk
pygtk.require('2.0')
import gtk,gobject
import os,re,threading,datetime
import config
import alsaaudio, wave
from time import sleep

class PlayPage:
    
    def __init__(self,pr_thread,conf):
        # parse additional info fro gtk-theme
        # thickens scroll-bar
        basic_rc ="""style "basic_style" {
	GtkRange::slider_width =30
	GtkRange::stepper_size =30
}

class "GtkRange" style "basic_style"
"""

        gtk.rc_parse_string(basic_rc)

        
        # get pointer to config
        self.conf = conf
        
        # get a reference to playrecthread
        self.playthread=pr_thread
        
        # read out folder given in config-file
        self.files,self.folder=self.getFolderContent()
########################
#      Datalist      #
########################
        
        self.list = gtk.ListStore(str,str)
        for i in range(len(self.files)):
            #insert filename, timestamp, length of file into the list 
            iter = self.list.append([self.files[i][0],self.files[i][1]])
        # widget for displaying the list    
        self.tree = gtk.TreeView(self.list)
        #columns for the list
        column1 = gtk.TreeViewColumn("filename")
        #column2 = gtk.TreeViewColumn("timestamp")
        column3 = gtk.TreeViewColumn("length")
        self.tree.append_column(column1)
        #self.tree.append_column(column2)
        self.tree.append_column(column3)

        cell = gtk.CellRendererText()
        # make columns resizable, sortable etc.
        column1.set_resizable(True)
        column1.pack_start(cell,False)
        column1.add_attribute(cell,'text',0)
        column1.set_sort_column_id(0)
        
#        column2.set_resizable(True)
#        column2.pack_start(cell,False)
#        column2.add_attribute(cell,'text',1)
#        column2.set_sort_column_id(1)
        
        column3.set_resizable(True)
        column3.pack_start(cell,False)
        column3.add_attribute(cell,'text',1)
        column3.set_sort_column_id(1)
       
        
# timelabel
        self.timelabel = gtk.Label()
        self.timelabel.set_use_markup(True)
        self.timelabel.set_property("height-request",50)
# event-box for changing timelabel-bg etc.
        self.eb = gtk.EventBox()
        self.eb.add(self.timelabel)


# button-images
        self.playImg = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_BUTTON)
        self.playImg.set_property("icon-size",6) 
        self.pauseImg = gtk.image_new_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_BUTTON)
        self.pauseImg.set_property("icon-size",6) 
        stopImg = gtk.image_new_from_stock(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_BUTTON)
        stopImg.set_property("icon-size",6) 
        rewImg = gtk.image_new_from_stock(gtk.STOCK_MEDIA_REWIND, gtk.ICON_SIZE_BUTTON)
        rewImg.set_property("icon-size",6) 
        fwImg = gtk.image_new_from_stock(gtk.STOCK_MEDIA_FORWARD, gtk.ICON_SIZE_BUTTON)
        fwImg.set_property("icon-size",6) 
        deleteImg = gtk.image_new_from_stock(gtk.STOCK_DELETE,gtk.ICON_SIZE_BUTTON)
        deleteImg.set_property("icon-size",6) 
###################
#     Buttons     #
###################              
        self.playBut = gtk.Button()
        self.playBut.set_image(self.playImg)
        self.playBut.set_property("height-request",100)
        if (not self.playthread is None):
            self.connectID = self.playBut.connect("clicked",self.play_file)
        
        self.stopBut = gtk.Button()
        self.stopBut.set_image(stopImg)
        if (not self.playthread is None):
            self.stopBut.connect("clicked",self.stop_playing)
        
        self.rewBut = gtk.Button()
        self.rewBut.set_image(rewImg)
        if (not self.playthread is None):
            self.rewID = self.rewBut.connect("clicked",self.rewind)
            
        self.fwBut = gtk.Button()
        self.fwBut.set_image(fwImg)
        if (not self.playthread is None):
            self.fwID = self.fwBut.connect("clicked",self.forward)
            
        self.deleteBut = gtk.Button()
        self.deleteBut.set_image(deleteImg)   
        if (not self.playthread is None):
            self.delID = self.deleteBut.connect("clicked",self.delete) 
#################
#    packing    #
#################    
        hbutton_box = gtk.HButtonBox()
        hbutton_box.set_layout(gtk.BUTTONBOX_SPREAD)
        
        hbutton_box.add(self.deleteBut)
        hbutton_box.add(self.rewBut)
        hbutton_box.add(self.stopBut)
        hbutton_box.add(self.playBut)
        hbutton_box.add(self.fwBut)
        
        self.sw = gtk.ScrolledWindow()
        self.sw.set_size_request(450,300)
        self.sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)
        self.sw.get_vscrollbar().set_property("width-request",40)
        self.sw.add(self.tree)
        
        self.mainBox = gtk.VBox()
        self.mainBox.pack_start(self.sw,True,True,10)
        self.mainBox.pack_start(self.eb,False,False,10)
        self.mainBox.pack_start(hbutton_box,False,False,10)
        
    def getMbox(self):
        #return the gui-part of this object
        return self.mainBox
    
    def getFolderContent(self):
        # read out config-file
        folder = self.conf.get_folder()
        
        # regexp - checking for compatible files - only wavs
        checker = re.compile(r".*.(wav)\Z")
        files=[]
        # get all files as ls-output
        ausgabe=os.popen(" ls -F " + folder + " | grep -v /$") 
          
        dateien = [zeile.strip() for zeile in ausgabe]
        
        filetypes = ['@','*','='] # filetypes created by ls -F (look at man ls)
        for fileprops in dateien:
            # get the filename
            if fileprops[len(fileprops)-1:] in filetypes:
                # when filetype-sign at the end - delete it
                filename = fileprops[:len(fileprops)-1]
            else:
                filename = fileprops
            #get the according timestamp
            ##timestamp = datetime.datetime.fromtimestamp(os.path.getmtime(folder +"/"+ filename)).isoformat().replace("T"," ")
            
            #get the length
            if filename[len(filename)-3:] == 'wav':
                length = self.get_wave_length(folder + "/" + filename)
            elif filename[len(filename)-3:] == 'ogg':
                length = self.get_ogg_length(folder + "/" + filename)
            else:
                length = '??:??'    
                
            if (checker.match(filename)!=None):
                # when file fits the regexp - add them
                files.append([filename,length])# timestamp was second argument
        files.sort()        
        return files,folder
    
    def play_file(self, widget):
        
        try:
            selection = self.tree.get_selection()
            filename = self.list.get_value(selection.get_selected()[1], 0)
        except:
            print "No file was selected!"
            self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("blue"))
            self.eb.show()
            self.timelabel.set_markup('<span size="12000">No file was selected!</span>')
            
        else:
            
            path = self.conf.get_folder()
            # filename + path = fullfilename = ffname
            ffname = path.strip() + "/" + filename.strip() 
            
            self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
            self.timelabel.set_markup('')
            self.eb.show()
            #make the playthread play the track 'ffname'
            # arguments are: filename, playPage [to access the timer when playing ends], duration [for the timer]
            self.playthread.play(ffname,self,self.list.get_value(selection.get_selected()[1], 1))
            self.switch_back_playBut(self.pause_playing,self.pauseImg)
            
            
    def stop_playing(self,widget):
        self.playthread.stop()
        self.switch_back_playBut(self.play_file,self.playImg)
        self.eb.hide()
    
    def pause_playing(self,widget):
        self.playthread.pause()
        self.switch_back_playBut(self.resume_playing,self.playImg)
        
    def resume_playing(self,widget):
        self.playthread.play()
        self.switch_back_playBut(self.pause_playing,self.pauseImg)
        
    def forward(self,widget):
        self.playthread.forward()
        self.switch_back_playBut(self.normal_playing,self.playImg)        
        
    def rewind(self,widget):
        self.playthread.rewind()
        self.switch_back_playBut(self.normal_playing,self.playImg)
        
    def delete(self,widget):
        # delete file
        try:
            selection = self.tree.get_selection()
            deleteme = self.list.get_value(selection.get_selected()[1], 0)
        except:
            print "No file was selected!"
            self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("blue"))
            self.eb.show()
            self.timelabel.set_markup('<span size="12000">No file was selected!</span>')
            
        else:
                ret = os.system("rm " + self.conf.get_folder() + '/' + deleteme)
                
                if ret == 0:
                    print self.conf.get_folder() + '/' + deleteme + " has been deleted."
                else:
                    print self.conf.get_folder() + '/' + deleteme + " could not be deleted."
        self.update_list()
                    
    def normal_playing(self,widget):
        # get back from slow or fast playback to normal playback 
        self.playthread.normal()
        self.switch_back_playBut(self.pause_playing,self.pauseImg)
        
#        self.fwBut.disconnect(self.fwID)
#        self.fwID = self.fwBut.connect("clicked",self.forward)
#        
#        self.rewBut.disconnect(self.rewID)
#        self.rewID = self.rewBut.connect("clicked",self.rewind)
        
    def switch_back_playBut(self,function,pic=None):
        # changing picture and function of play-button
        self.playBut.disconnect(self.connectID)
        self.connectID = self.playBut.connect("clicked",function)
        if pic != None:
            self.playBut.set_image(pic)
            
    def get_wave_length(self,filename):
        
        wfile = wave.open(filename, "r")
        length = (1.0 * wfile.getnframes()) / wfile.getframerate()
        wfile.close()
        length = round(length)
        
        if length > 60.0:
            mins = int(length/60)
            secs = int(length%60)
            if mins < 10:
                mins = '0' + str(mins)
            if secs < 10:
                secs = '0' + str(secs-1 if secs > 0 else 0)
            time = str(mins) + ":" + str(secs)
        else:
            
            time = "00:" + ('0' + str(int(length)) if length < 10 else str(int(length)))
        return time
    
    def get_ogg_length(self,filename):
        length = 'x:xx '
        return length
            
    def update_list(self):
        # update/reload filelist
        
        self.files,self.folder=self.getFolderContent()
        self.list.clear()
        for i in range(len(self.files)):
            iter = self.list.append([self.files[i][0],self.files[i][1]])
