#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    

import threading,datetime,os
from time import sleep,time
import alsaaudio,wave
import datetime
from gtk.gdk import threads_leave,threads_enter
import littlehelpers
import gtk


class PlayRecThread(threading.Thread):
    # if death == True --> thread-loop will stop
    death = False
    
    def __init__(self,conf,aset):
        
        
        threading.Thread.__init__(self)
    
    	self.conf = conf    
        self.aset = aset
	
        self.pcm_play= None
        self.pcm_rec = None
        self.format = alsaaudio.PCM_FORMAT_S16_LE
        self.period_size = 80
	
        if self.aset.recType==2:
			self.channels = 2
        else:
			self.channels = 1
        
        
        # factor for speeding up or slowing down playing :D
        # 1.5 creates funny but not too fast/slow effects
        self.play_manipulation = 2.0
        
        self.filename = ''
        self.play_dur = ''
        self.tmp_pos = 0
        
    # references to playPage and recPage, workaround for switching playBut
        self.pp = None  
        self.recp = None
        

    #bools for controlling play- and rec-process
        # false-false means: nothing happens
        self.play_me = False
        self.record_me = False
        
        self.stop_playing = False
        self.stop_recording = False
        
        self.pause_me = False
        
        self.fw = False
        self.rw = False
        self.norm = False
        
    def run(self):
        # main thread - either playing or recording
        # just checking bools consumpts the least cpu i think
        while not self.death:
            if (self.play_me == True):
                self.__play_track()
            elif (self.record_me == True):
                self.__record_track()
            else:
                sleep(0.1)
    
    # methods: play, record, stop, pause, forward, rewind, normal, kill, run
    # are called from recPage or playPage to
    # make the thread play or stop or forward or sth. else
    # by controlling it via setting the appropriate booleans
    def play(self,filename= '',playpage = None,duration=''):
         
        playing = False
        resumed = False
        # resume from pause
        if self.pause_me == True:
            self.pause_me = False
            resumed = True
        
        if playpage !=None:
            #reference to playpage
            self.pp = playpage
            
        if duration != '':
            self.play_dur = duration
        # only start from idle loop when nothing happens
        if self.play_me == False and self.record_me == False:
            self.filename = filename
            self.play_me=True 
            playing = True
   
        return playing,resumed # dont know what to do with that but seems useful
        
        
    def record(self,recpage,filename= ''):
        recording = False
        resumed = False
        # resume from pause
        if self.pause_me == True:
            self.pause_me = False
            resumed = True
            
        if recpage != None:
            self.recp = recpage
        # only start from idle loop when nothing happens
        if self.record_me == False and self.play_me == False:
            if filename == '':
                self.filename = self.__get_standard_filename('wav')
            else:
                self.filename = filename
            self.record_me = True
            recording = True
        
        return recording,resumed
        
        
    def stop(self):
    # stop thread from playing or recording
        if (self.play_me == True):
            self.stop_playing=True
        if (self.record_me == True):
            self.stop_recording=True
        
    def pause(self):
        # currently only implemented for playing
        self.pause_me = True
        
    def forward(self):
        self.fw = True
        
    def rewind(self):
        self.rw = True
        
    def normal(self):
        # playing with normal speed
        self.norm = True
        
    def __play_track(self):
        # doing the real playing-work
        
       
        # opening track to be played in read-mode  
        track = wave.open(self.filename,"r")
        
        self.load_pcm_play(track)
        
        print "playing " +self.filename
        # preparing for playloop

        # first read of a maximum of 80 frames
        data = track.readframes(self.period_size)
        # writing it to the device, means playing it
        self.pcm_play.write(data)
        
        # start timer - with access to the playpage-timelabel
        # and informations about the track to be more accurate when pausing, forwarding etc.
        timer = littlehelpers.TimelabelUpdater(self.pp.timelabel,self.play_dur,track,track.getframerate())
        timer.start()
        
        #play-loop
        # when a read of the wave-file returns 0, it's its end
        while data and not (self.stop_playing or self.death):
            if self.pause_me == True:
                timer.pause()
                sleep(0.1)
            elif self.fw == True:
                # play a little faster
                # old working method(om2008.12) - not working under fso/shr
                #self.pcm_play.setrate(int(track.getframerate()*self.play_manipulation))
                self.load_pcm_play(track,int(track.getframerate()*self.play_manipulation))
                self.fw = False
            elif self.rw == True:
                # plaaaayyy aaaaaa littttttttllle sloooowwwwwer
                #currently broken under shr/fso
                print "Sorry! Playing slower currently does not work on fso/shr." 
                #self.pcm_play.setrate(int(track.getframerate()/self.play_manipulation))
                #self.load_pcm_play(track,int(track.getframerate()/self.play_manipulation))
                self.rw = False
            elif self.norm == True:
                # play with normal speed again
                self.load_pcm_play(track)
                self.norm = False  
            else:
                # the timer resumes from pause as well         
                timer.resume()
                # read frames from the track
                data = track.readframes(self.period_size)
                try:
                    self.pcm_play.write(data)

                except(alsaaudio.ALSAAudioError), e:
                    # accessing the gtk-gui you have to enter the main loop
                    # or else it will take minutes till your changes apply
                    threads_enter()
                    if self.pp != None:
                        self.pp.timelabel.set_markup('<span size="12000">Play-Error!!!</span>')
                    threads_leave()
                    print "Play-Error!!!", e.message
        track.close()
        timer.stop()
        self.pcm_play = None
        
        print "end of playing"
        threads_enter()
        if self.pp != None:
            self.pp.switch_back_playBut(self.pp.play_file,self.pp.playImg)
            #hide timer
            self.pp.eb.hide()
        threads_leave()
    # return to idle-state - looping and doing nothing but wait
        self.pause_me = False
        self.play_me = False
        self.stop_playing = False
        
    def __record_track(self):
        # open pcm-device
        if  os.popen("uname -n").readline().strip() == "om-gta02":
            self.pcm_rec = alsaaudio.PCM(alsaaudio.PCM_CAPTURE,alsaaudio.PCM_NORMAL,self.conf.get_soundcard())
        else:
            self.pcm_rec = alsaaudio.PCM(alsaaudio.PCM_CAPTURE,alsaaudio.PCM_NORMAL)
            
        # configure device
        self.pcm_rec.setchannels(self.channels)
        self.pcm_rec.setrate(self.conf.get_rate())
        self.pcm_rec.setperiodsize(self.period_size)
        self.pcm_rec.setformat(self.format)
        
        print "start recording"
        
        # start timer
        timer = littlehelpers.TimelabelUpdater(self.recp.timelabel)
        timer.start()
        
        # initialize and start extra save-thread
        # arguments for wirting correct wave-header
        saver = littlehelpers.saveThread(self.filename,self.channels,self.conf.get_rate(),alsaaudio.PCM_FORMAT_S16_LE)
        saver.start()
        
        while not (self.stop_recording or self.death):
                #l = length, data= sound
                l,data = self.pcm_rec.read()
                if data:
                    threads_enter() # don't know why this is needed, but it seems to be
                    littlehelpers.saveThread.data_list.append(data)
                    threads_leave()
        saver.stop()    # set stop-bool
        timer.stop()    # set stop-bool for timer
        saver.join()    # wait for saver to finish
        saver.close()   # then close the track 
        
        self.pcm_rec = None
        
        threads_enter()
        if self.recp != None:
            # clean-up timelabel 
            # place for a message?
            self.recp.timelabel.set_markup('')
        threads_leave()
        
        print "end of recording"
        
        # return to idle-configuration- doing nothing
        self.pause_me = False 
        self.record_me = False
        self.stop_recording = False
        
    def kill(self):
        # stop idle thread, 
        # but first wait for playing or recording to be finished
        # called when main-window is closed 
        self.death = True
        
    def __get_standard_filename(self,wavorogg): # private
        #TODO: filename-patterns to be chosen in config-file
        fileprefix=""
        if (self.aset.recType == 0):
            fileprefix="mic"
        elif (self.aset.recType == 1):
            fileprefix="gsm-in"
        elif (self.aset.recType == 2):
            fileprefix="gsm_mic"
        filename = self.conf.get_folder() + "/" +fileprefix +"_"+ datetime.datetime.now().isoformat().replace('T','_')[:19]
        if wavorogg == 'wav':
             filename += ".wav"
        elif wavorogg == 'ogg':
             filename += ".ogg"
        return filename
    
        
    def load_pcm_play(self,track,rate=None):
        #workaround for fso/shr reload whole pcm-object for faster playback
        if self.pcm_play:
           self.pcm_play=None
         # opening pcm-device for playing
        if  os.popen("uname -n").readline().strip() == "om-gta02":
            self.pcm_play = alsaaudio.PCM(alsaaudio.PCM_PLAYBACK,alsaaudio.PCM_NORMAL,self.conf.get_soundcard())
        else:
            self.pcm_play = alsaaudio.PCM(alsaaudio.PCM_PLAYBACK,alsaaudio.PCM_NORMAL)
            
        #get configuration from wave.file or set directly
        self.pcm_play.setchannels(track.getnchannels())
        if not rate:
            self.pcm_play.setrate(track.getframerate())
        else:
            self.pcm_play.setrate(rate)
            
        # the number of frames (one audio sample per channel) to be written 
        # to the device at once
        self.pcm_play.setperiodsize(self.period_size)
        
        # format
        #TODO: get this from wave-file
        self.pcm_play.setformat(self.format)
        
        
        
        
