#!/usr/bin/env python
# -*- coding: iso-8859-15 -*-

#    Dictator 0.1 - the most undemocratic dictation- and call-recording-software ever
#    Copyright (C) 2009  Matthias Felsche, Email: matthiasfelsche at web dot de
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#    


import pygtk
pygtk.require('2.0')
import gtk
import alsaaudio

class RecPage:
    
    def __init__(self,pr_thread, conf,aset):
        
        # playrecthread for accessing it 
        self.recthread = pr_thread
        # the same
        self.conf = conf
        self.aset = aset
########################
# buttons, labels etc. #
########################
        
#images
        confImg = gtk.image_new_from_stock(gtk.STOCK_EDIT, gtk.ICON_SIZE_MENU)
        confImg.set_property("icon-size",6)
        
        alsaImg = gtk.image_new_from_stock(gtk.STOCK_PREFERENCES,gtk.ICON_SIZE_MENU)
        alsaImg.set_property("icon-size",6)
        
        self.recImg = gtk.Image()
        pixbuf = self.recImg.render_icon(gtk.STOCK_MEDIA_RECORD, gtk.ICON_SIZE_DIALOG)
        pixbuf = pixbuf.scale_simple(100,100,gtk.gdk.INTERP_BILINEAR)
        self.recImg.set_from_pixbuf(pixbuf)
        
        self.stopImg = gtk.Image()
        pixbuf = self.recImg.render_icon(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_DIALOG)
        pixbuf = pixbuf.scale_simple(100,100,gtk.gdk.INTERP_BILINEAR)
        self.stopImg.set_from_pixbuf(pixbuf)
        
        self.pauseImg = gtk.Image()
        pixbuf = self.recImg.render_icon(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_DIALOG)
        pixbuf = pixbuf.scale_simple(100,100,gtk.gdk.INTERP_BILINEAR)
        self.pauseImg.set_from_pixbuf(pixbuf)

#buttons  
    
        self.recBut = gtk.Button()
        self.recBut.set_image(self.recImg)
        if (not self.recthread is None):
            self.connectID = self.recBut.connect("clicked",self.record_file)  
        
        self.stopBut = gtk.Button()
        self.stopBut.set_image(self.stopImg)
        if (not self.recthread is None):
            self.stopBut.connect("clicked",self.stop)
        # config-button for record-configuration
        
        self.alsaBut = gtk.Button()
        self.alsaBut.set_image(alsaImg)
        self.alsaBut.connect("clicked",self.aset_show)
        self.alsaBut.set_property("height-request",100)
        
        self.configBut = gtk.Button()
        self.configBut.set_image(confImg)
        self.configBut.connect("clicked",self.conf.open_window)
        
#recordlabel
        self.recordlabel = gtk.Label(self.aset.get_rectype())
#timelabel
        self.timelabel = gtk.Label()
        self.timelabel.set_use_markup(True)
        self.timelabel.set_property("height-request",50)

################
#   PACKING    #
################
        
#button box - contains rec- and stop-buttons
        bBox= gtk.HBox()      
        bBox.pack_start(self.recBut,True,True,10)
        bBox.pack_start(self.stopBut,True,True,10)       
        bBox.set_property("height-request",200)
        
#recbox - contains buttonbox and timelabel        
        self.recBox = gtk.VBox()
        self.recBox.pack_start(bBox,True,True,20)

#event-box - for changing background of timer-label
        self.eb = gtk.EventBox()
        self.eb.add(self.timelabel)
        
        self.recBox.pack_start(self.eb,True,False,20)
#mainBox - contains recbox and configbutton - what is everything gui-related      
        self.mainBox = gtk.VBox(False,5)
        self.mainBox.pack_start(self.recBox,False,False,5) 
        
        self.cBut_box=gtk.HBox(True,5)
        self.cBut_box.pack_start(self.configBut,True,True,0) 
        self.cBut_box.pack_start(self.alsaBut,True,True,0)
        self.mainBox.pack_start(self.cBut_box,False,False,5)
        
        self.mainBox.pack_start(self.recordlabel,False,False,5)
        
        
    def getMbox(self):
        #returning what is packed into the window
        return self.mainBox
    
    def record_file(self,widget):
        # reload necessary alsa-state, show timer and change color
        self.aset.load_recstate()
        self.eb.show()
        self.eb.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("red"))
        # make playrecthread begin recording
        self.recthread.record(self)
        
        
    def pause(self,widget):
        # not implemented anymore, just destroyed my wav-file
        self.recthread.pause()

        
    def resume(self,widget):
        # connected to pause and so - not implemented
        self.recthread.record(None)

        
    def stop(self,widget):
        # stop recording
        self.recthread.stop()
        self.eb.hide()
        
    def aset_show(self,widget):
        # changing recmode is only enabled when
        # dictator is not recording and not playing anything
        if self.recthread.record_me == False and self.recthread.play_me == False:
            self.aset.show()
            
    def update_record_label(self,window=None):
        #show configured record-state
        self.recordlabel.set_text(self.aset.get_rectype())
        
